import 'dart:typed_data';
import 'package:flutter/material.dart';
import 'package:observable/observable.dart';
import 'package:xfxbase/XFDataItem.dart';
import 'package:xfxbase/_XFX/XF_Col.dart';
import 'package:xfxbase/_XFX/XF_View.dart';
import 'package:xfxwidgets/XF_MAIN/XApp.dart';
import 'package:xfxwidgets/XF_MAIN/XAppState.dart';
import 'package:xfxwidgets/xMediaItem.dart';
import 'package:xfxwidgets/xfxwidgets.dart';
import 'package:xtoolspackage/xtoolspackage.dart';
import 'package:image/image.dart' as img;
import 'XElenco.dart';

class ElXBase_ElencoDraggable<T> extends XElenco<ElXBase_ElencoDraggable<T>, XMediaItem> {
  ElXBase_ElencoDraggable(
    this.viewToUse,
    this.title, {
    Key? key,
    super.liXMediaToUse,
    Widget? xDrawerMenu,
    this.liToUse,
    super.xApp,
    Function(XMediaItem)? functToDelete,
    super.rootItemEdited,
    super.itemEdited,
    super.onTapItem,
    super.BTNEmptyList_BL,
    super.xLayout_Row_CellWidth,
    super.xLayout_Row_Cell,
    super.styleForItemCell,
  }) : super(
          title,
          viewToUse,
          pageMode_Active: true,
          liDetts: liToUse,
          onLongTapItem: functToDelete != null ? (item) => functToDelete(item) : null,
          xDrawerMenu: xDrawerMenu,
          key: key,
          title_Style: XStyles.xStyTextForTitle(textColor: XColors.foregroundLight),
          title_Color: (XColors.foregroundLight),
        );
  List<XMediaItem>? liToUse;
  Function(XMediaItem)? functToDelete;
  XView viewToUse;
  String title;
  @override
  ElXBase_ElencoDraggable_State<T> createState() => ElXBase_ElencoDraggable_State<T>();
}

class ElXBase_ElencoDraggable_State<T> extends XElencoState<ElXBase_ElencoDraggable<T>, XMediaItem> {}

class ElencoDraggable<T> extends ElXBase_ElencoDraggable<T> {
  ElencoDraggable(
    this.obj,
    this.title,
    this.viewToUse, {
    this.isSch = false,
    super.liXMediaToUse,
    super.xApp,
    super.liToUse,
    super.functToDelete,
    super.onTapItem,
    super.BTNEmptyList_BL,
    super.rootItemEdited,
    super.itemEdited,
    super.xLayout_Row_CellWidth,
    super.xLayout_Row_Cell,
    super.styleForItemCell,
  }) : super(viewToUse, title);
  T? obj;
  bool? isSch;
  XView viewToUse;
  String title;
  @override
  _El_ElencoDraggable_State<T> createState() => _El_ElencoDraggable_State<T>();
}

class _El_ElencoDraggable_State<T> extends ElXBase_ElencoDraggable_State<T> {
  @override
  void initState() {
    widget.view = (widget as ElXBase_ElencoDraggable).viewToUse;
    widget.schedaMode = (widget as ElencoDraggable).isSch;
    widget.xApp = (widget as ElXBase_ElencoDraggable).xApp;
    widget.allowAdd = true;
    widget.title_Text = (widget as ElXBase_ElencoDraggable).title;
    super.initState();
    widget.onLongTapItem = (p0) async => await widget.onLongTapItem!(p0);
    widget.onTapBack = () => Navigator.pop(context);
    // widget.cmd_Add = (p0) => super.cmd_GetMedia(setState, (widget as ElencoXMediaItem).obj!).then((value) => null).then((value) => initXFilters()).then((value) => rebuildAllChildren(context));
  }

  // @override
  // Widget? xLayout_ItemWidget(XMediaItem xMedia) {
  //   var w = Container(
  //     child: ,
  //   );
  //   return w;
  // }

  @override
  Widget xLayout_ElencoWidget() {
    return Expanded(
        child: ReorderableListView(
            padding: EdgeInsets.all(8.0),
            // header: Text(w),
            children: widget.liDetts!.map((item) => xLayout_ItemWidget(item) ?? Container()).toList(),
            onReorder: (oldIndex, newIndex) {
              setState(() {
                if (newIndex > oldIndex) {
                  newIndex -= 1;
                }
                final String item = widget.liDetts!.removeAt(oldIndex);
                widget.liDetts!.insert(newIndex, item);
              });
            }));
  }
}
